Mandolin m => JCRev r => dac;
JCRev rl => dac.left;
JCRev rr => dac.right;

sndbuf bass => r;
sndbuf snare => rr;
sndbuf cowL => rr;
sndbuf cowH => rl;
sndbuf tom1 => rl;
sndbuf tom2 => r;
sndbuf tom3 => rr;
sndbuf cymb => rr;
Shakers shake => r;

"707bass144.raw" => bass.read;
"707snar144.raw" => snare.read;
"707cowbl44Hi.raw" => cowH.read;
"707cowbl44Low.raw" => cowL.read;
"707tom144.raw" => tom1.read;
"707tom244.raw" => tom2.read;
"707tom344.raw" => tom3.read;
"707crash44.raw" => cymb.read;

7 => shake.which;
5.0 => shake.gain;

0.1 => r.mix;
1.5 => bass.gain;
1.0 => snare.gain;
0.5 => cowL.gain;
1.2 => tom1.gain;
1.2 => tom2.gain;
1.2 => tom3.gain;
1.2 => cymb.gain;

[1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.6,
 1.0, 0.0, 0.0, 0.0, 0.6, 0.0, 0.4, 0.6] @=> float bassp[];
[0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.4, 0.0,
 0.0, 0.0, 0.5, 0.0, 0.6, 0.2, 0.4, 0.6] @=> float snarep[];
[1.0, 0.0, 0.8, 0.0, 0.8, 0.0, 0.8, 0.0,
 0.8, 0.0, 0.8, 0.0, 0.8, 0.0, 0.8, 0.0] @=> float shakep[];
[0.0, 0.0, 0.4, 0.0, 0.4, 0.4, 0.8, 0.0,
 0.2, 0.3, 0.0, 0.3, 0.0, 0.5, 0.4, 0.3] @=> float cowp[];
[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
 0.0, 0.0, 0.0, 0.3, 0.8, 0.3, 0.6, 0.4] @=> float tomp[];
 
0 => int i;
0 => int j;
0 => int k;
float temp;

0.1 => r.mix;
0.1 => rl.mix;
0.1 => rr.mix;
0.4 => m.gain;

[12, 11, 9, 7, 5, 4, 2, 0,
7, 9, 9, 11, 11, 12,
12, 12, 11, 9, 7, 7, 5, 4,
12, 12, 11, 9, 7, 7, 5, 4,
4, 4, 4, 4, 4, 5, 7, 
5, 4, 2, 2, 2, 2, 4, 5,
4, 2, 0, 12, 9, 7, 5, 4, 5, 4, 2, 0] @=> int joyp[];  // Pitches

[0.4, 0.3, 0.1, 0.6, 0.2, 0.4, 0.4, 0.6,
0.2, 0.6, 0.2, 0.6, 0.2, 1.4,
0.2,0.2,0.2,0.2,0.2,0.3, 0.1, 0.2,
0.2,0.2,0.2,0.2,0.2,0.3, 0.1, 0.2,
0.2,0.2,0.2,0.2,0.1,0.1,0.6,
0.1,0.1,0.2,0.2,0.2,0.1,0.1,0.6,
0.1,0.1,0.2,0.4,0.2,0.3,0.1,0.2,0.2,0.4,0.4,0.8] @=> float joyd[]; // Durations

spork ~ drum();

while (1)       {
    while (i < 57)        {
	std.mtof(60 + joyp[i]) => m.freq;
	1.0 => m.pluck;
        1.5 * joyd[i] :: second => now;
        i + 1 => i;
    }	 
    0 => i;
}

fun void drum()	{
    while (1)	{
        if (std.rand2f(0.0,1.0) < bassp[j]) { 
	    0 => bass.pos;  
	    std.rand2f(0.4,bassp[j]) => bass.gain;
	}
        if (std.rand2f(0.0,1.0) < snarep[j]) { 
	    0 => snare.pos;  
	    std.rand2f(0.4,snarep[j]) => snare.gain;
	}
        if (std.rand2f(0.0,1.0) < cowp[j]) { 
	    if (std.rand2f(0.0,1.0) < 0.5)	{
		0 => cowH.pos;
	        std.rand2f(0.4,cowp[j]) => cowH.gain;
	    }
	    else	{
		0 => cowL.pos;  
	        std.rand2f(0.4,cowp[j]) => cowL.gain;
	    }
	}
        if (std.rand2f(0.0,1.0) < tomp[k]) {
	    std.rand2f(0.0,1.0) => temp;
	    if (temp < 0.333)	{
		0 => tom1.pos;
	        std.rand2f(0.4,tomp[k]) => tom1.gain;
	    }
	    else if (temp < 0.666)	{
		0 => tom2.pos;  
	        std.rand2f(0.4,tomp[k]) => tom2.gain;
	    }
	    else	{
		0 => tom3.pos;  
	        std.rand2f(0.4,tomp[k]) => tom3.gain;
	    }
	}
	if (k == 30)	{
	    0 => cymb.pos;  
	    std.rand2f(0.4,1.0) => cymb.gain;
	}
        if (std.rand2f(0.0,1.0) < shakep[j]) { 
	    std.rand2f(0.4,shakep[j]) => shake.noteOn;
	}
        1 + j => j;
	if (j == 16) 0 => j;
        1 + k => k;
	if (k == 32) 0 => k;
        1.5 * 0.1 :: second => now;
    }
}

